// Copyright (c) 2015, <your name>. All rights reserved. Use of this source code
// is governed by a BSD-style license that can be found in the LICENSE file.

// TODO: Put public facing types in this file.

library OrientDb_Server.base;

import 'dart:io';
import 'dart:async';
import 'dart:convert';
/// Checks if you are awesome. Spoiler: you are.
class OrientConfig {
  String dbUser;
  String password;
  String host;
  int port;

  OrientConfig(String user, String pass, [String host="127.0.0.1", int port=2480]) {
    this.dbUser = user;
    this.password = pass;
    this.host = host;
    this.port = port;
  }

  @override
    String toString() => "$dbUser:$password@$host:$port";
}

Future<List<String>> databaseList(OrientConfig config) {
  Completer completer = new Completer();
  HttpClient client = new HttpClient();
  List<String> list = new List();
  client.getUrl(Uri.parse("http://$config/listDatabases")).then((clientRequest){
    return clientRequest.close();
  }).then((clientResponse) {
    clientResponse.transform(UTF8.decoder).listen((content){
      Map json = JSON.decode(content);
      for (String database in json['databases']) {
        list.add(database);
      }
      completer.complete(list);
    });

  });
  return completer.future;

}