library OrientDb_Server.database;

import 'package:OrientDb_Server/src/orientdb_server_base.dart';
import 'dart:async';
import 'dart:io';

const LOCAL = 'plocal';
const MEMORY  = 'memory';
const DOC = 'document';
const GRAPH = 'graph';

Future<int> createDatabase(OrientConfig config, String database, [String storage=LOCAL, String dbType=DOC]) {
  Completer completer = new Completer();
  HttpClient client = new HttpClient();
  client.postUrl(Uri.parse("http://$config/database/$database/$storage/$dbType")).then((clientRequest){
    return clientRequest.close();
  }).then((clientResponse) {
    clientResponse.listen((content)=> completer.complete(clientResponse.statusCode));
  });
  return completer.future;
}

Future<bool> databaseExists(OrientConfig config, String database) {
  Completer completer = new Completer();
  databaseList(config).then((list) {
    bool found =  (list.contains(database));
    completer.complete(found);
  });
  return completer.future;
}

Future<int> dropDatabase(OrientConfig config, String database) {
  Completer completer = new Completer();
  HttpClient client = new HttpClient();
  client.deleteUrl(Uri.parse("http://$config/database/$database")).then((clientRequest) {
    return clientRequest.close();
  }).then((clientResponse) {
    clientResponse.listen((content){
      completer.complete(clientResponse.statusCode);
    });
  });
  return completer.future;
}